﻿Imports System
Imports System.Runtime.InteropServices
Imports VaxTeleServerCOMLib

Public Class cVaxServerCOM

    Public Const SIP_DEFAULT_PORT As Integer = 5060

    Public Const VAX_ROUTE_TYPE_USER As Integer = 0
    Public Const VAX_ROUTE_TYPE_LINE As Integer = 1
    Public Const VAX_ROUTE_TYPE_QUEUE As Integer = 2
    Public Const VAX_ROUTE_TYPE_RING_GROUP As Integer = 3
    Public Const VAX_ROUTE_TYPE_CALL_PICKUP As Integer = 4
    Public Const VAX_ROUTE_TYPE_ROOM As Integer = 5
    Public Const VAX_ROUTE_TYPE_CALL_PARK As Integer = 6
    Public Const VAX_ROUTE_TYPE_STEALTH_LISTEN As Integer = 7

    Public Const VAX_PEER_TYPE_USER As Integer = 0
    Public Const VAX_PEER_TYPE_LINE As Integer = 1

    Public Const VAX_LINE_TYPE_UDP As Integer = 0
    Public Const VAX_LINE_TYPE_TCP As Integer = 1
    Public Const VAX_LINE_TYPE_TLS As Integer = 2

    Public Const VAX_REC_MUTE_TYPE_NONE As Integer = -1
    Public Const VAX_REC_MUTE_TYPE_SPEAK As Integer = 0
    Public Const VAX_REC_MUTE_TYPE_LISTEN As Integer = 1
    Public Const VAX_REC_MUTE_TYPE_BOTH As Integer = 2

    '///////////////////////////////////////////////////////////

    Public Const VAX_WAVE_REC_TYPE_MONO_PCM As Integer = 0
    Public Const VAX_WAVE_REC_TYPE_STEREO_PCM As Integer = 1
    Public Const VAX_WAVE_REC_TYPE_MONO_G711U As Integer = 2
    Public Const VAX_WAVE_REC_TYPE_STEREO_G711U As Integer = 3
    Public Const VAX_WAVE_REC_TYPE_MONO_G711A As Integer = 4
    Public Const VAX_WAVE_REC_TYPE_STEREO_G711A As Integer = 5

    '///////////////////////////////////////////////////////////

    Public Const VAX_CALL_CHANNEL_ZERO As Integer = 0
    Public Const VAX_CALL_CHANNEL_ONE As Integer = 1

    '///////////////////////////////////////////////////////////

    Public Const VAX_DTMF_TYPE_RFC2833 As Integer = 0
    Public Const VAX_DTMF_TYPE_SIP_INFO As Integer = 1
    Public Const VAX_DTMF_TYPE_INBAND As Integer = 2

    Public Const VAX_PLAY_WAVE_MODE_EXCLUSIVE As Integer = 0
    Public Const VAX_PLAY_WAVE_MODE_MIXED As Integer = 1

    '///////////////////////////////////////////////////////////

    Public Const VAX_CODEC_GSM610 As Integer = 0
    Public Const VAX_CODEC_ILBC As Integer = 1
    Public Const VAX_CODEC_G711A As Integer = 2
    Public Const VAX_CODEC_G711U As Integer = 3
    Public Const VAX_CODEC_G729 As Integer = 4

    Public Const VAX_CODEC_TOTAL_COUNT As Integer = 5

    '///////////////////////////////////////////////////////////

    Public Const VAX_TRANSFER_TYPE_BLIND As Integer = 0
    Public Const VAX_TRANSFER_TYPE_CONSULT As Integer = 1

    '///////////////////////////////////////////////////////////

    Public Const VAX_CUSTOM_HEADER_REQ_ID_INVITE As Integer = 0

    '///////////////////////////////////////////////////////////

    Public Const VAX_STEALTH_LISTENER_FREE As Integer = 0
    Public Const VAX_STEALTH_LISTENER_BUSY As Integer = 1

    '///////////////////////////////////////////////////////////

    Public Const VAX_QUEUE_PROCESS_MODE_RING_ALL As Integer = 0
    Public Const VAX_QUEUE_PROCESS_MODE_HUNT_RANDOM As Integer = 1
    Public Const VAX_QUEUE_PROCESS_MODE_ROUND_ROBIN As Integer = 2
    Public Const VAX_QUEUE_PROCESS_MODE_LEAST_ANSWERED As Integer = 3
    Public Const VAX_QUEUE_PROCESS_MODE_LEAST_TALK_TIME As Integer = 4
    Public Const VAX_QUEUE_PROCESS_MODE_LONGEST_WAITING As Integer = 5
    Public Const VAX_QUEUE_PROCESS_MODE_PRIORITIZED_HUNT As Integer = 6

    Public Const VAX_QUEUE_PROCESS_TYPE_FREE As Integer = 0
    Public Const VAX_QUEUE_PROCESS_TYPE_ANY As Integer = 1

    Public Const VAX_QUEUE_PLAY_WAVE_EVENT_TYPE_MUSIC As Integer = 0
    Public Const VAX_QUEUE_PLAY_WAVE_EVENT_TYPE_RING As Integer = 1

    Public Const VAX_QUEUE_AGENT_AVAILABLE_STATUS As Integer = 0
    Public Const VAX_QUEUE_AGENT_UNAVAILABLE_STATUS As Integer = 1

    '///////////////////////////////////////////////////////////

    Public Const VAX_RING_GROUP_PROCESS_MODE_RING_ALL As Integer = 0
    Public Const VAX_RING_GROUP_PROCESS_MODE_HUNT_RANDOM As Integer = 1
    Public Const VAX_RING_GROUP_PROCESS_MODE_ROUND_ROBIN As Integer = 2
    Public Const VAX_RING_GROUP_PROCESS_MODE_LEAST_ANSWERED As Integer = 3
    Public Const VAX_RING_GROUP_PROCESS_MODE_LEAST_TALK_TIME As Integer = 4
    Public Const VAX_RING_GROUP_PROCESS_MODE_LONGEST_WAITING As Integer = 5
    Public Const VAX_RING_GROUP_PROCESS_MODE_PRIORITIZED_HUNT As Integer = 6

    Public Const VAX_RING_GROUP_PROCESS_TYPE_FREE As Integer = 0
    Public Const VAX_RING_GROUP_PROCESS_TYPE_ANY As Integer = 1

    '///////////////////////////////////////////////////////////

    Public Const VAX_CLOSED_REASON_CODE_HANGUP As Integer = 0
    Public Const VAX_CLOSED_REASON_CODE_SESSION_LOST As Integer = 1
    Public Const VAX_CLOSED_REASON_CODE_MOVED As Integer = 2
    Public Const VAX_CLOSED_REASON_CODE_TRANSFERED As Integer = 3
    Public Const VAX_CLOSED_REASON_CODE_REJECTED As Integer = 4
    Public Const VAX_CLOSED_REASON_CODE_FAILED As Integer = 5
    Public Const VAX_CLOSED_REASON_CODE_CANCELLED As Integer = 6
    Public Const VAX_CLOSED_REASON_CODE_TIMEOUT As Integer = 7
    Public Const VAX_CLOSED_REASON_CODE_CLOSED As Integer = 8

    '///////////////////////////////////////////////////////////

    Public Const VAX_ACCESS_PCM_TYPE_ALL_NONE As Integer = -1
    Public Const VAX_ACCESS_PCM_TYPE_EVENT_NONE As Integer = 0
    Public Const VAX_ACCESS_PCM_TYPE_EVENT_MEDIA_INBOUND As Integer = 1
    Public Const VAX_ACCESS_PCM_TYPE_EVENT_MEDIA_OUTBOUND As Integer = 2
    Public Const VAX_ACCESS_PCM_TYPE_PIPE_NONE As Integer = 3
    Public Const VAX_ACCESS_PCM_TYPE_PIPE_MEDIA_INBOUND As Integer = 4
    Public Const VAX_ACCESS_PCM_TYPE_PIPE_MEDIA_OUTBOUND As Integer = 5
    Public Const VAX_ACCESS_PCM_TYPE_PIPE_DUPLEX_MEDIA_INBOUND As Integer = 6

    '///////////////////////////////////////////////////////////

    Public Const VAX_MEDIA_FLOW_TYPE_SEND_RECV As Integer = 0
    Public Const VAX_MEDIA_FLOW_TYPE_SEND_ONLY As Integer = 1
    Public Const VAX_MEDIA_FLOW_TYPE_RECV_ONLY As Integer = 2
    Public Const VAX_MEDIA_FLOW_TYPE_INACTIVE As Integer = 3

    '///////////////////////////////////////////////////////////

    Public Const VAX_AUDIO_TYPE_NORMAL As Integer = 0
    Public Const VAX_AUDIO_TYPE_USER As Integer = 1
    Public Const VAX_AUDIO_TYPE_ADMIN As Integer = 2

    Public Const VAX_VIDEO_TYPE_NORMAL As Integer = 0
    Public Const VAX_VIDEO_TYPE_USER As Integer = 1
    Public Const VAX_VIDEO_TYPE_ADMIN As Integer = 2

    '///////////////////////////////////////////////////////////

    Public Const VAX_PUSH_PROVIDER_IOS As Integer = 0
    Public Const VAX_PUSH_PROVIDER_ANDROID As Integer = 1

    '///////////////////////////////////////////////////////////

    Public Const VAX_MEDIA_DETECT_VAD_TYPE_INBOUND As Integer = 0
    Public Const VAX_MEDIA_DETECT_VAD_TYPE_OUTBOUND As Integer = 1

    '///////////////////////////////////////////////////////////

    Private m_objVaxServerSIP As VaxServerSIP = New VaxServerSIP()

    Public Sub New()

        AddHandler m_objVaxServerSIP.OnLineRegisterTrying, AddressOf OnLineRegisterTrying
        AddHandler m_objVaxServerSIP.OnLineRegisterFailed, AddressOf OnLineRegisterFailed
        AddHandler m_objVaxServerSIP.OnLineRegisterSuccess, AddressOf OnLineRegisterSuccess

        AddHandler m_objVaxServerSIP.OnLineUnRegisterTrying, AddressOf OnLineUnRegisterTrying
        AddHandler m_objVaxServerSIP.OnLineUnRegisterFailed, AddressOf OnLineUnRegisterFailed
        AddHandler m_objVaxServerSIP.OnLineUnRegisterSuccess, AddressOf OnLineUnRegisterSuccess

        AddHandler m_objVaxServerSIP.OnUnRegisterUser, AddressOf OnUnRegisterUser
        AddHandler m_objVaxServerSIP.OnRegisterUser, AddressOf OnRegisterUser
        AddHandler m_objVaxServerSIP.OnRegisterUserSuccess, AddressOf OnRegisterUserSuccess
        AddHandler m_objVaxServerSIP.OnRegisterUserFailed, AddressOf OnRegisterUserFailed

        AddHandler m_objVaxServerSIP.OnIncomingCall, AddressOf OnIncomingCall
        AddHandler m_objVaxServerSIP.OnCallSessionConnecting, AddressOf OnCallSessionConnecting
        AddHandler m_objVaxServerSIP.OnCallSessionFailed, AddressOf OnCallSessionFailed
        AddHandler m_objVaxServerSIP.OnCallSessionConnected, AddressOf OnCallSessionConnected
        AddHandler m_objVaxServerSIP.OnCallSessionClosed, AddressOf OnCallSessionClosed

        AddHandler m_objVaxServerSIP.OnCallSessionLost, AddressOf OnCallSessionLost
        AddHandler m_objVaxServerSIP.OnCallSessionHangup, AddressOf OnCallSessionHangup
        AddHandler m_objVaxServerSIP.OnCallSessionTimeout, AddressOf OnCallSessionTimeout
        AddHandler m_objVaxServerSIP.OnCallSessionCancelled, AddressOf OnCallSessionCancelled

        AddHandler m_objVaxServerSIP.OnCallSessionOnHold, AddressOf OnCallSessionOnHold
        AddHandler m_objVaxServerSIP.OnCallSessionOffHold, AddressOf OnCallSessionOffHold

        AddHandler m_objVaxServerSIP.OnCallSessionTransferBlind, AddressOf OnCallSessionTransferBlind
        AddHandler m_objVaxServerSIP.OnCallSessionTransferConsult, AddressOf OnCallSessionTransferConsult

        AddHandler m_objVaxServerSIP.OnCallSessionTransfering, AddressOf OnCallSessionTransfering
        AddHandler m_objVaxServerSIP.OnCallSessionTransferFailed, AddressOf OnCallSessionTransferFailed
        AddHandler m_objVaxServerSIP.OnCallSessionTransferTimeout, AddressOf OnCallSessionTransferTimeout
        AddHandler m_objVaxServerSIP.OnCallSessionTransfered, AddressOf OnCallSessionTransfered

        AddHandler m_objVaxServerSIP.OnChatMessageText, AddressOf OnChatMessageText
        AddHandler m_objVaxServerSIP.OnChatMessageTyping, AddressOf OnChatMessageTyping
        AddHandler m_objVaxServerSIP.OnChatStatusSubscribe, AddressOf OnChatStatusSubscribe

        AddHandler m_objVaxServerSIP.OnChatStatusSendSubscribeSuccess, AddressOf OnChatStatusSendSubscribeSuccess
        AddHandler m_objVaxServerSIP.OnChatStatusSendSubscribeFailed, AddressOf OnChatStatusSendSubscribeFailed

        AddHandler m_objVaxServerSIP.OnChatMessageSuccess, AddressOf OnChatMessageSuccess
        AddHandler m_objVaxServerSIP.OnChatMessageFailed, AddressOf OnChatMessageFailed
        AddHandler m_objVaxServerSIP.OnChatMessageTimeout, AddressOf OnChatMessageTimeout

        AddHandler m_objVaxServerSIP.OnDetectedDigitDTMF, AddressOf OnDetectedDigitDTMF

        AddHandler m_objVaxServerSIP.OnOutgoingDiagnosticLog, AddressOf OnOutgoingDiagnosticLog
        AddHandler m_objVaxServerSIP.OnIncomingDiagnosticLog, AddressOf OnIncomingDiagnosticLog

        AddHandler m_objVaxServerSIP.OnVaxTeleTick, AddressOf OnVaxTeleTick

        AddHandler m_objVaxServerSIP.OnSendTimeoutVM, AddressOf OnSendTimeoutVM
        AddHandler m_objVaxServerSIP.OnSendSuccessVM, AddressOf OnSendSuccessVM

        AddHandler m_objVaxServerSIP.OnCallSessionDialToneStarted, AddressOf OnCallSessionDialToneStarted
        AddHandler m_objVaxServerSIP.OnCallSessionDialToneEnded, AddressOf OnCallSessionDialToneEnded

        AddHandler m_objVaxServerSIP.OnCallSessionPlayWaveDone, AddressOf OnCallSessionPlayWaveDone
        AddHandler m_objVaxServerSIP.OnConferenceRoomPlayWaveDone, AddressOf OnConferenceRoomPlayWaveDone

        AddHandler m_objVaxServerSIP.OnCallSessionCreated, AddressOf OnCallSessionCreated
        AddHandler m_objVaxServerSIP.OnCallSessionDetectedAMD, AddressOf OnCallSessionDetectedAMD

        AddHandler m_objVaxServerSIP.OnCallSessionRecordedWaveREC, AddressOf OnCallSessionRecordedWaveREC
        AddHandler m_objVaxServerSIP.OnConferenceRoomRecordedWaveREC, AddressOf OnConferenceRoomRecordedWaveREC

        AddHandler m_objVaxServerSIP.OnBusyLampSubscribe, AddressOf OnBusyLampSubscribe
        AddHandler m_objVaxServerSIP.OnBusyLampUnSubscribe, AddressOf OnBusyLampUnSubscribe
        AddHandler m_objVaxServerSIP.OnBusyLampSubscribeSuccess, AddressOf OnBusyLampSubscribeSuccess
        AddHandler m_objVaxServerSIP.OnBusyLampSubscribeFailed, AddressOf OnBusyLampSubscribeFailed

        AddHandler m_objVaxServerSIP.OnVaxErrorLog, AddressOf OnVaxErrorLog

        AddHandler m_objVaxServerSIP.OnAddCallSessionToQueueSuccess, AddressOf OnAddCallSessionToQueueSuccess
        AddHandler m_objVaxServerSIP.OnAddCallSessionToQueueFailed, AddressOf OnAddCallSessionToQueueFailed

        AddHandler m_objVaxServerSIP.OnAddCallSessionToRingGroupSuccess, AddressOf OnAddCallSessionToRingGroupSuccess
        AddHandler m_objVaxServerSIP.OnAddCallSessionToRingGroupFailed, AddressOf OnAddCallSessionToRingGroupFailed

        AddHandler m_objVaxServerSIP.OnSendReqTransferCallTimeout, AddressOf OnSendReqTransferCallTimeout
        AddHandler m_objVaxServerSIP.OnSendReqTransferCallAccepted, AddressOf OnSendReqTransferCallAccepted
        AddHandler m_objVaxServerSIP.OnSendReqTransferCallFailed, AddressOf OnSendReqTransferCallFailed
        AddHandler m_objVaxServerSIP.OnQualityReportPUBLISH, AddressOf OnQualityReportPUBLISH
        AddHandler m_objVaxServerSIP.OnBusyLampSendStatus, AddressOf OnBusyLampSendStatus

        AddHandler m_objVaxServerSIP.OnServerConnectingREC, AddressOf OnServerConnectingREC
        AddHandler m_objVaxServerSIP.OnServerConnectedREC, AddressOf OnServerConnectedREC
        AddHandler m_objVaxServerSIP.OnServerFailedREC, AddressOf OnServerFailedREC
        AddHandler m_objVaxServerSIP.OnServerTimeoutREC, AddressOf OnServerTimeoutREC
        AddHandler m_objVaxServerSIP.OnServerHungupREC, AddressOf OnServerHungupREC

        AddHandler m_objVaxServerSIP.OnQueuePlayWaveStarted, AddressOf OnQueuePlayWaveStarted
        AddHandler m_objVaxServerSIP.OnQueuePlayWaveEnded, AddressOf OnQueuePlayWaveEnded

        AddHandler m_objVaxServerSIP.OnQueueAgentConnectStarted, AddressOf OnQueueAgentConnectStarted
        AddHandler m_objVaxServerSIP.OnQueueAgentConnectTrying, AddressOf OnQueueAgentConnectTrying
        AddHandler m_objVaxServerSIP.OnQueueAgentConnectFailed, AddressOf OnQueueAgentConnectFailed
        AddHandler m_objVaxServerSIP.OnQueueAgentConnectTimeout, AddressOf OnQueueAgentConnectTimeout
        AddHandler m_objVaxServerSIP.OnQueueAgentConnectSuccess, AddressOf OnQueueAgentConnectSuccess

        AddHandler m_objVaxServerSIP.OnSendNotifyMsgSuccess, AddressOf OnSendNotifyMsgSuccess
        AddHandler m_objVaxServerSIP.OnSendNotifyMsgFailed, AddressOf OnSendNotifyMsgFailed

        AddHandler m_objVaxServerSIP.OnCallSessionErrorLog, AddressOf OnCallSessionErrorLog

        AddHandler m_objVaxServerSIP.OnCallParkPlayWaveStarted, AddressOf OnCallParkPlayWaveStarted
        AddHandler m_objVaxServerSIP.OnCallParkPlayWaveEnded, AddressOf OnCallParkPlayWaveEnded

        AddHandler m_objVaxServerSIP.OnStealthListenerAttached, AddressOf OnStealthListenerAttached
        AddHandler m_objVaxServerSIP.OnCallSessionAccessAudioPCM, AddressOf OnCallSessionAccessAudioPCM

        AddHandler m_objVaxServerSIP.OnCallSessionPushSIP, AddressOf OnCallSessionPushSIP
        AddHandler m_objVaxServerSIP.OnRegisterUserPushSIP, AddressOf OnRegisterUserPushSIP

        AddHandler m_objVaxServerSIP.OnSendReqHoldCallSuccess, AddressOf OnSendReqHoldCallSuccess
        AddHandler m_objVaxServerSIP.OnSendReqHoldCallTrying, AddressOf OnSendReqHoldCallTrying
        AddHandler m_objVaxServerSIP.OnSendReqHoldCallTimeout, AddressOf OnSendReqHoldCallTimeout
        AddHandler m_objVaxServerSIP.OnSendReqHoldCallFailed, AddressOf OnSendReqHoldCallFailed

        AddHandler m_objVaxServerSIP.OnSendReqUnHoldCallSuccess, AddressOf OnSendReqUnHoldCallSuccess
        AddHandler m_objVaxServerSIP.OnSendReqUnHoldCallTrying, AddressOf OnSendReqUnHoldCallTrying
        AddHandler m_objVaxServerSIP.OnSendReqUnHoldCallTimeout, AddressOf OnSendReqUnHoldCallTimeout
        AddHandler m_objVaxServerSIP.OnSendReqUnHoldCallFailed, AddressOf OnSendReqUnHoldCallFailed

        AddHandler m_objVaxServerSIP.OnAttackDetectedScanSIP, AddressOf OnAttackDetectedScanSIP
        AddHandler m_objVaxServerSIP.OnAttackDetectedFloodSIP, AddressOf OnAttackDetectedFloodSIP
        AddHandler m_objVaxServerSIP.OnAttackDetectedBruteForceSIP, AddressOf OnAttackDetectedBruteForceSIP

        AddHandler m_objVaxServerSIP.OnCallSessionMediaDetectStartedVAD, AddressOf OnCallSessionMediaDetectStartedVAD
        AddHandler m_objVaxServerSIP.OnCallSessionMediaDetectCompletedVAD, AddressOf OnCallSessionMediaDetectCompletedVAD
        AddHandler m_objVaxServerSIP.OnCallSessionMediaDetectExpiredVAD, AddressOf OnCallSessionMediaDetectExpiredVAD

    End Sub

    Public Function GetVersionSDK() As String
        Return m_objVaxServerSIP.GetVersionSDK()
    End Function

    Public Function GetVersionFile() As String
        Return m_objVaxServerSIP.GetVersionFile()
    End Function

    Public Sub SetLicenseKey(ByVal sLicenseKey As String)
        m_objVaxServerSIP.SetLicenseKey(sLicenseKey)
    End Sub

    Public Function Initialize(ByVal sDomainRealm As String) As Boolean
        Return m_objVaxServerSIP.Initialize(sDomainRealm)
    End Function

    Public Sub UnInitialize()
        m_objVaxServerSIP.UnInitialize()
    End Sub

    Public Function CryptoMediaNONE(ByVal bForced As Boolean) As Boolean
        Return m_objVaxServerSIP.CryptoMediaNONE(bForced)
    End Function

    Public Function CryptoMediaSDP(ByVal bForced As Boolean) As Boolean
        Return m_objVaxServerSIP.CryptoMediaSDP(bForced)
    End Function

    Public Function OpenNetworkUDP(ByVal sListenIP As String, ByVal nListenPort As Integer) As Boolean
        Return m_objVaxServerSIP.OpenNetworkUDP(sListenIP, nListenPort)
    End Function

    Public Function OpenNetworkTCP(ByVal sListenIP As String, ByVal nListenPort As Integer) As Boolean
        Return m_objVaxServerSIP.OpenNetworkTCP(sListenIP, nListenPort)
    End Function

    Public Function OpenNetworkTLS(ByVal sListenIP As String, ByVal nListenPort As Integer, ByVal sCertPEM As String) As Boolean
        Return m_objVaxServerSIP.OpenNetworkTLS(sListenIP, nListenPort, sCertPEM)
    End Function

    Public Sub CloseNetworkUDP()
        m_objVaxServerSIP.CloseNetworkUDP()
    End Sub

    Public Sub CloseNetworkTCP()
        m_objVaxServerSIP.CloseNetworkTCP()
    End Sub

    Public Sub CloseNetworkTLS()
        m_objVaxServerSIP.CloseNetworkTLS()
    End Sub

    Public Function SetListenPortRangeRTP(ByVal nListenStartPort As Integer, ByVal nListenEndPort As Integer) As Boolean
        Return m_objVaxServerSIP.SetListenPortRangeRTP(nListenStartPort, nListenEndPort)
    End Function

    Public Function SetNetworkMediaRTP(ByVal sListenIP As String, ByVal nListenStartPort As Integer) As Boolean
        Return m_objVaxServerSIP.SetNetworkMediaRTP(sListenIP, nListenStartPort)
    End Function

    Public Function AutoForwardStatusResponseSIP(ByVal nSessionId As Integer, ByVal bDisable As Boolean) As Boolean
        Return m_objVaxServerSIP.AutoForwardStatusResponseSIP(nSessionId, bDisable)
    End Function

    Public Function AddUser(ByVal sUserName As String, ByVal sPassword As String, ByVal sAudioCodecList As String) As Boolean
        Return m_objVaxServerSIP.AddUser(sUserName, sPassword, sAudioCodecList)
    End Function

    Public Sub RemoveUser(ByVal sUserName As String)
        m_objVaxServerSIP.RemoveUser(sUserName)
    End Sub

    Public Function AcceptRegister(ByVal nRegId As Integer) As Boolean
        Return m_objVaxServerSIP.AcceptRegister(nRegId)
    End Function

    Public Function RejectRegister(ByVal nRegId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String) As Boolean
        Return m_objVaxServerSIP.RejectRegister(nRegId, nStatusCode, sReasonPhrase)
    End Function

    Public Function AttachRegister(ByVal nRegId As Integer, ByVal sUserName As String) As Boolean
        Return m_objVaxServerSIP.AttachRegister(nRegId, sUserName)
    End Function

    Public Function AuthRegister(ByVal nRegId As Integer) As Boolean
        Return m_objVaxServerSIP.AuthRegister(nRegId)
    End Function

    Public Function RegisterUserExpiry(ByVal nExpiry As Integer) As Boolean
        Return m_objVaxServerSIP.RegisterUserExpiry(nExpiry)
    End Function

    Public Function SetUserPushSIP(ByVal sUserName As String, ByVal nProviderPN As Integer, ByVal sProjectPN As String, ByVal sDevicePN As String) As Boolean
        Return m_objVaxServerSIP.SetUserPushSIP(sUserName, nProviderPN, sProjectPN, sDevicePN)
    End Function

    Public Function AddLine(ByVal sLineName As String, ByVal nLineType As Integer, ByVal sDisplayName As String, ByVal sUserName As String, ByVal sAuthUser As String, ByVal sAuthPwd As String, ByVal sDomainRealm As String, ByVal sServerAddr As String, ByVal nServerPort As Integer, ByVal sAudioCodecList As String) As Boolean
        Return m_objVaxServerSIP.AddLine(sLineName, nLineType, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sServerAddr, nServerPort, sAudioCodecList)
    End Function

    Public Sub RemoveLine(ByVal sLineName As String)
        m_objVaxServerSIP.RemoveLine(sLineName)
    End Sub

    Public Function RegisterLine(ByVal sLineName As String, ByVal nExpire As Integer) As Boolean
        Return m_objVaxServerSIP.RegisterLine(sLineName, nExpire)
    End Function

    Public Function UnRegisterLine(ByVal sLineName As String) As Boolean
        Return m_objVaxServerSIP.UnRegisterLine(sLineName)
    End Function

    Public Function AcceptCallSession(ByVal nSessionId As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String, ByVal sToPeerName As String, ByVal sRouteUID As String, ByVal nTimeout As Integer) As Boolean
        Return m_objVaxServerSIP.AcceptCallSession(nSessionId, sCallerName, sCallerId, sDialNo, sToPeerName, sRouteUID, nTimeout)
    End Function

    Public Function RejectCallSession(ByVal nSessionId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String) As Boolean
        Return m_objVaxServerSIP.RejectCallSession(nSessionId, nStatusCode, sReasonPhrase)
    End Function

    Public Function CloseCallSession(ByVal nSessionId As Integer) As Boolean
        Return m_objVaxServerSIP.CloseCallSession(nSessionId)
    End Function

    Public Function DialCallSession(ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String, ByVal sToPeerName As String, ByVal nTimeout As Integer) As Integer
        Return m_objVaxServerSIP.DialCallSession(sCallerName, sCallerId, sDialNo, sToPeerName, nTimeout)
    End Function

    Public Function AcceptTransferBlind(ByVal nTransfererSessionId As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sTransferTo As String, ByVal sToPeerName As String, ByVal sRouteUID As String, ByVal nTimeout As Integer) As Boolean
        Return m_objVaxServerSIP.AcceptTransferBlind(nTransfererSessionId, sCallerName, sCallerId, sTransferTo, sToPeerName, sRouteUID, nTimeout)
    End Function

    Public Function AcceptTransferConsult(ByVal nTransfererSessionId As Integer, ByVal nTransferToSessionId As Integer) As Boolean
        Return m_objVaxServerSIP.AcceptTransferConsult(nTransfererSessionId, nTransferToSessionId)
    End Function

    Public Sub RejectTransfer(ByVal nSessionId As Integer)
        m_objVaxServerSIP.RejectTransfer(nSessionId)
    End Sub

    Public Function PlayWaveStartToCallSession(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nWaveId As Integer, ByVal bLoop As Boolean, ByVal nPlayPosPCM As Integer) As Boolean
        Return m_objVaxServerSIP.PlayWaveStartToCallSession(nSessionId, nChannelId, nWaveId, bLoop, nPlayPosPCM)
    End Function

    Public Sub PlayWaveStopToCallSession(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nWaveId As Integer)
        m_objVaxServerSIP.PlayWaveStopToCallSession(nSessionId, nChannelId, nWaveId)
    End Sub

    Public Function PlayWaveSetVolumeToCallSession(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nWaveId As Integer, ByVal nVolume As Integer) As Boolean
        Return m_objVaxServerSIP.PlayWaveSetVolumeToCallSession(nSessionId, nChannelId, nWaveId, nVolume)
    End Function

    Public Function PlayWaveSetModeTypeToCallSession(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nPlayModeType As Integer) As Boolean
        Return m_objVaxServerSIP.PlayWaveSetModeTypeToCallSession(nSessionId, nChannelId, nPlayModeType)
    End Function

    Public Function RecordWaveSetCacheSize(ByVal nCacheSize As Integer) As Boolean
        Return m_objVaxServerSIP.RecordWaveSetCacheSize(nCacheSize)
    End Function

    Public Function RecordWaveStartToCallSession(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal sFileName As String, ByVal nTypeREC As Integer) As Boolean
        Return m_objVaxServerSIP.RecordWaveStartToCallSession(nSessionId, nChannelId, sFileName, nTypeREC)
    End Function

    Public Sub RecordWaveStopToCallSession(ByVal nSessionId As Integer, ByVal nChannelId As Integer)
        m_objVaxServerSIP.RecordWaveStopToCallSession(nSessionId, nChannelId)
    End Sub

    Public Function RecordWavePauseToCallSession(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal bEnable As Boolean) As Boolean
        Return m_objVaxServerSIP.RecordWavePauseToCallSession(nSessionId, nChannelId, bEnable)
    End Function

    Public Function LoadWaveFile(ByVal sFileName As String) As Integer
        Return m_objVaxServerSIP.LoadWaveFile(sFileName)
    End Function

    Public Function LoadWavePCM(ByVal aDataPCM As Byte(), ByVal nSizePCM As Integer) As Integer
        Dim hHandleGC As GCHandle = GCHandle.Alloc(aDataPCM, GCHandleType.Pinned)
        Dim AddrDataPCM As IntPtr = hHandleGC.AddrOfPinnedObject()
        Dim lDataPCM As Long = AddrDataPCM.ToInt64()
        Dim nWaveId As Integer = m_objVaxServerSIP.LoadWavePCM(lDataPCM, nSizePCM, 0)
        hHandleGC.Free()
        Return nWaveId
    End Function

    Public Sub UnLoadWaveID(ByVal nWaveId As Integer)
        m_objVaxServerSIP.UnLoadWaveID(nWaveId)
    End Sub

    Public Function LoadMusicHold(ByVal sFileName As String) As Boolean
        Return m_objVaxServerSIP.LoadMusicHold(sFileName)
    End Function

    Public Sub UnLoadMusicHold()
        m_objVaxServerSIP.UnLoadMusicHold()
    End Sub

    Public Function AcceptOnHoldRequest(ByVal nSessionId As Integer) As Boolean
        Return m_objVaxServerSIP.AcceptOnHoldRequest(nSessionId)
    End Function

    Public Function AcceptOffHoldRequest(ByVal nSessionId As Integer) As Boolean
        Return m_objVaxServerSIP.AcceptOffHoldRequest(nSessionId)
    End Function

    Public Function AcceptChatMessage(ByVal nChatMsgId As Integer, ByVal sToPeerName As String) As Boolean
        Return m_objVaxServerSIP.AcceptChatMessage(nChatMsgId, sToPeerName)
    End Function

    Public Sub RejectChatMessage(ByVal nChatMsgId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
        m_objVaxServerSIP.RejectChatMessage(nChatMsgId, nStatusCode, sReasonPhrase)
    End Sub

    Public Function SendChatMessageText(ByVal sMsgFrom As String, ByVal sMsgTo As String, ByVal sMsgText As String, ByVal sToPeerName As String) As Integer
        Return m_objVaxServerSIP.SendChatMessageText(sMsgFrom, sMsgTo, sMsgText, sToPeerName)
    End Function

    Public Function AcceptChatStatusSubscribe(ByVal nStatusSubscribe As Integer, ByVal sMsgFrom As String, ByVal sMsgTo As String, ByVal sToPeerName As String) As Boolean
        Return m_objVaxServerSIP.AcceptChatStatusSubscribe(nStatusSubscribe, sMsgFrom, sMsgTo, sToPeerName)
    End Function

    Public Sub RejectChatStatusSubscribe(ByVal nStatusSubscribe As Integer, ByVal sMsgFrom As String, ByVal sMsgTo As String)
        m_objVaxServerSIP.RejectChatStatusSubscribe(nStatusSubscribe, sMsgFrom, sMsgTo)
    End Sub

    Public Function OpenConferenceRoom(ByVal sRoomName As String) As Boolean
        Return m_objVaxServerSIP.OpenConferenceRoom(sRoomName)
    End Function

    Public Sub CloseConferenceRoom(ByVal sRoomName As String)
        m_objVaxServerSIP.CloseConferenceRoom(sRoomName)
    End Sub

    Public Function AddCallSessionToConferenceRoom(ByVal sRoomName As String, ByVal nSessionId As Integer) As Boolean
        Return m_objVaxServerSIP.AddCallSessionToConferenceRoom(sRoomName, nSessionId)
    End Function

    Public Sub RemoveCallSessionFromConferenceRoom(ByVal nSessionId As Integer)
        m_objVaxServerSIP.RemoveCallSessionFromConferenceRoom(nSessionId)
    End Sub

    Public Function PlayWaveStartToConferenceRoom(ByVal sRoomName As String, ByVal nWaveId As Integer, ByVal bLoop As Boolean, ByVal nPlayPosPCM As Integer) As Boolean
        Return m_objVaxServerSIP.PlayWaveStartToConferenceRoom(sRoomName, nWaveId, bLoop, nPlayPosPCM)
    End Function

    Public Function PlayWaveStopToConferenceRoom(ByVal sRoomName As String, ByVal nWaveId As Integer) As Boolean
        Return m_objVaxServerSIP.PlayWaveStopToConferenceRoom(sRoomName, nWaveId)
    End Function

    Public Function PlayWaveSetVolumeToConferenceRoom(ByVal sRoomName As String, ByVal nWaveId As Integer, ByVal nVolume As Integer) As Boolean
        Return m_objVaxServerSIP.PlayWaveSetVolumeToConferenceRoom(sRoomName, nWaveId, nVolume)
    End Function

    Public Function RecordWaveStartToConferenceRoom(ByVal sRoomName As String, ByVal sFileName As String, ByVal nTypeREC As Integer) As Boolean
        Return m_objVaxServerSIP.RecordWaveStartToConferenceRoom(sRoomName, sFileName, nTypeREC)
    End Function

    Public Function RecordWaveStopToConferenceRoom(ByVal sRoomName As String) As Boolean
        Return m_objVaxServerSIP.RecordWaveStopToConferenceRoom(sRoomName)
    End Function

    Public Function RecordWavePauseToConferenceRoom(ByVal sRoomName As String, ByVal bEnable As Boolean) As Boolean
        Return m_objVaxServerSIP.RecordWavePauseToConferenceRoom(sRoomName, bEnable)
    End Function

    Public Function AudioSessionLost(ByVal bEnable As Boolean, ByVal nTimeout As Integer) As Boolean
        Return m_objVaxServerSIP.AudioSessionLost(bEnable, nTimeout)
    End Function

    Public Function SendInfoVM(ByVal sUserName As String, ByVal nNewMsgCount As Integer, ByVal nOldMsgCount As Integer, ByVal bMsgWaiting As Boolean) As Integer
        Return m_objVaxServerSIP.SendInfoVM(sUserName, nNewMsgCount, nOldMsgCount, bMsgWaiting)
    End Function

    Public Function StartVaxTeleTick(ByVal nTickId As Integer, ByVal nElapse As Integer) As Boolean
        Return m_objVaxServerSIP.StartVaxTeleTick(nTickId, nElapse)
    End Function

    Public Function StopVaxTeleTick(ByVal nTickId As Integer) As Boolean
        Return m_objVaxServerSIP.StopVaxTeleTick(nTickId)
    End Function

    Public Function SetUserAgentName(ByVal sName As String) As Boolean
        Return m_objVaxServerSIP.SetUserAgentName(sName)
    End Function

    Public Function GetUserAgentName() As String
        Return m_objVaxServerSIP.GetUserAgentName().ToString()
    End Function

    Public Function SetSessionNameSDP(ByVal sName As String) As Boolean
        Return m_objVaxServerSIP.SetSessionNameSDP(sName)
    End Function

    Public Function GetSessionNameSDP() As String
        Return m_objVaxServerSIP.GetSessionNameSDP().ToString()
    End Function

    Public Function SendDigitDTMF(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal sDigitDTMF As String, ByVal nTypeDTMF As Integer) As Boolean
        Return m_objVaxServerSIP.SendDigitDTMF(nSessionId, nChannelId, sDigitDTMF, nTypeDTMF)
    End Function

    Public Function DetectDigitDTMF(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nTypeDTMF As Integer, ByVal bEnable As Boolean, ByVal nMilliSecondTimeout As Integer) As Boolean
        Return m_objVaxServerSIP.DetectDigitDTMF(nSessionId, nChannelId, nTypeDTMF, bEnable, nMilliSecondTimeout)
    End Function

    Public Function GetVaxErrorCode() As Integer
        Return m_objVaxServerSIP.GetVaxErrorCode()
    End Function

    Public Function DialToneToCallSession(ByVal bEnable As Boolean, ByVal nSessionId As Integer, ByVal nWaveId As Integer) As Boolean
        Return m_objVaxServerSIP.DialToneToCallSession(bEnable, nSessionId, nWaveId)
    End Function

    Public Function DiagnosticLogSIP(ByVal bInbound As Boolean, ByVal bOutbound As Boolean) As Boolean
        Return m_objVaxServerSIP.DiagnosticLogSIP(bInbound, bOutbound)
    End Function

    Public Function SplitCallSession(ByVal nSessionId As Integer, ByVal nChannelId As Integer) As Integer
        Return m_objVaxServerSIP.SplitCallSession(nSessionId, nChannelId)
    End Function

    Public Function MoveCall(ByVal nSrcSessionId As Integer, ByVal nChannelId As Integer, ByVal nDscSessionId As Integer) As Boolean
        Return m_objVaxServerSIP.MoveCall(nSrcSessionId, nChannelId, nDscSessionId)
    End Function

    Public Function CallSessionSendStatusResponse(ByVal nSessionId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String, ByVal sContactURI As String) As Boolean
        Return m_objVaxServerSIP.CallSessionSendStatusResponse(nSessionId, nStatusCode, sReasonPhrase, sContactURI)
    End Function

    Public Function CallSessionDetectAMD(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal bEnable As Boolean, ByVal nAnalysisTime As Integer, ByVal nSilenceTime As Integer, ByVal nSilenceCount As Integer) As Boolean
        Return m_objVaxServerSIP.CallSessionDetectAMD(nSessionId, nChannelId, bEnable, nAnalysisTime, nSilenceTime, nSilenceCount)
    End Function

    Public Function AddCustomHeader(ByVal nReqId As Integer, ByVal sName As String, ByVal sValue As String) As Boolean
        Return m_objVaxServerSIP.AddCustomHeader(nReqId, sName, sValue)
    End Function

    Public Function RemoveCustomHeader(ByVal nReqId As Integer, ByVal sName As String) As Boolean
        Return m_objVaxServerSIP.RemoveCustomHeader(nReqId, sName)
    End Function

    Public Function RemoveCustomHeaderAll(ByVal nReqId As Integer) As Boolean
        Return m_objVaxServerSIP.RemoveCustomHeaderAll(nReqId)
    End Function

    Public Function GetCallSessionTxCodec(ByVal nSessionId As Integer, ByVal nChannelId As Integer) As Integer
        Return m_objVaxServerSIP.GetCallSessionTxCodec(nSessionId, nChannelId)
    End Function

    Public Function GetCallSessionRxCodec(ByVal nSessionId As Integer, ByVal nChannelId As Integer) As Integer
        Return m_objVaxServerSIP.GetCallSessionRxCodec(nSessionId, nChannelId)
    End Function

    Public Function BusyLampSubscribeAccept(ByVal nSubScrbId As Integer, ByVal bAuthenticate As Boolean, ByVal nExpires As Integer) As Boolean
        Return m_objVaxServerSIP.BusyLampSubscribeAccept(nSubScrbId, bAuthenticate, nExpires)
    End Function

    Public Function BusyLampSubscribeReject(ByVal nSubScrbId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String) As Boolean
        Return m_objVaxServerSIP.BusyLampSubscribeReject(nSubScrbId, nStatusCode, sReasonPhrase)
    End Function

    Public Function BusyLampSendStatus(ByVal sFromUserName As String, ByVal sToUserName As String, ByVal nStateId As Integer) As Boolean
        Return m_objVaxServerSIP.BusyLampSendStatus(sFromUserName, sToUserName, nStateId)
    End Function

    Public Function GetCallCount() As Integer
        Return m_objVaxServerSIP.GetCallCount()
    End Function

    Public Function GetCallSessionHeaderCallId(ByVal nSessionId As Integer, ByVal nChannelId As Integer) As String
        Return m_objVaxServerSIP.GetCallSessionHeaderCallId(nSessionId, nChannelId)
    End Function

    Public Function CallSessionMuteVoice(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal bListen As Boolean, ByVal bSpeak As Boolean) As Boolean
        Return m_objVaxServerSIP.CallSessionMuteVoice(nSessionId, nChannelId, bListen, bSpeak)
    End Function

    Public Function VideoCOMM(ByVal bEnable As Boolean) As Boolean
        Return m_objVaxServerSIP.VideoCOMM(bEnable)
    End Function

    Public Function AddRingGroup(ByVal sGroupName As String) As Boolean
        Return m_objVaxServerSIP.AddRingGroup(sGroupName)
    End Function

    Public Sub RemoveRingGroup(ByVal sGroupName As String)
        m_objVaxServerSIP.RemoveRingGroup(sGroupName)
    End Sub

    Public Function AddRingGroupAgent(ByVal sGroupName As String, ByVal sUserName As String) As Boolean
        Return m_objVaxServerSIP.AddRingGroupAgent(sGroupName, sUserName)
    End Function

    Public Sub RemoveRingGroupAgent(ByVal sGroupName As String, ByVal sUserName As String)
        m_objVaxServerSIP.RemoveRingGroupAgent(sGroupName, sUserName)
    End Sub

    Public Sub SetRingGroupProcessMode(ByVal sGroupName As String, ByVal nProcessMode As Integer, ByVal nProcessType As Integer)
        m_objVaxServerSIP.SetRingGroupProcessMode(sGroupName, nProcessMode, nProcessType)
    End Sub

    Public Function SetRingGroupAgentPriority(ByVal sGroupName As String, ByVal sUserName As String, ByVal nPriority As Integer) As Boolean
        Return m_objVaxServerSIP.SetRingGroupAgentPriority(sGroupName, sUserName, nPriority)
    End Function

    Public Function AddCallSessionToRingGroup(ByVal sGroupName As String, ByVal sCallerName As String, ByVal sCallFrom As String, ByVal nSessionId As Integer) As Boolean
        Return m_objVaxServerSIP.AddCallSessionToRingGroup(sGroupName, sCallerName, sCallFrom, nSessionId)
    End Function

    Public Function RemoveCallSessionFromRingGroup(ByVal nSessionId As Integer) As Boolean
        Return m_objVaxServerSIP.RemoveCallSessionFromRingGroup(nSessionId)
    End Function

    Public Function AddCallPickUpGroup(ByVal sGroupName As String) As Boolean
        Return m_objVaxServerSIP.AddCallPickUpGroup(sGroupName)
    End Function

    Public Sub RemoveCallPickUpGroup(ByVal sGroupName As String)
        m_objVaxServerSIP.RemoveCallPickUpGroup(sGroupName)
    End Sub

    Public Function AddCallPickUpGroupMember(ByVal sGroupName As String, ByVal sUserName As String) As Boolean
        Return m_objVaxServerSIP.AddCallPickUpGroupMember(sGroupName, sUserName)
    End Function

    Public Sub RemoveCallPickUpGroupMember(ByVal sGroupName As String, ByVal sUserName As String)
        m_objVaxServerSIP.RemoveCallPickUpGroupMember(sGroupName, sUserName)
    End Sub

    Public Function PickUpCall(ByVal nSessionId As Integer, ByVal sUserName As String) As Boolean
        Return m_objVaxServerSIP.PickUpCall(nSessionId, sUserName)
    End Function

    Public Function ParkCallSession(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nSlotId As Integer) As Boolean
        Return m_objVaxServerSIP.ParkCallSession(nSessionId, nChannelId, nSlotId)
    End Function

    Public Function ConnectToParkedCallSession(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nSlotId As Integer) As Boolean
        Return m_objVaxServerSIP.ConnectToParkedCallSession(nSessionId, nChannelId, nSlotId)
    End Function

    Public Function AddQueue(ByVal sQueueName As String) As Boolean
        Return m_objVaxServerSIP.AddQueue(sQueueName)
    End Function

    Public Sub RemoveQueue(ByVal sQueueName As String)
        m_objVaxServerSIP.RemoveQueue(sQueueName)
    End Sub

    Public Function AddQueueAgent(ByVal sQueueName As String, ByVal sUserName As String) As Boolean
        Return m_objVaxServerSIP.AddQueueAgent(sQueueName, sUserName)
    End Function

    Public Sub RemoveQueueAgent(ByVal sQueueName As String, ByVal sUserName As String)
        m_objVaxServerSIP.RemoveQueueAgent(sQueueName, sUserName)
    End Sub

    Public Sub SetQueueAgentPriority(ByVal sQueueName As String, ByVal sUserName As String, ByVal nPriority As Integer)
        m_objVaxServerSIP.SetQueueAgentPriority(sQueueName, sUserName, nPriority)
    End Sub

    Public Function SetQueueAgentStatus(ByVal sQueueName As String, ByVal sAgentName As String, ByVal nStatusId As Integer) As Boolean
        Return m_objVaxServerSIP.SetQueueAgentStatus(sQueueName, sAgentName, nStatusId)
    End Function

    Public Sub SetQueueProcessMode(ByVal sQueueName As String, ByVal nProcessMode As Integer, ByVal nProcessType As Integer)
        m_objVaxServerSIP.SetQueueProcessMode(sQueueName, nProcessMode, nProcessType)
    End Sub

    Public Function AddCallSessionToQueue(ByVal sQueueName As String, ByVal sCallerName As String, ByVal sCallerId As String, ByVal nSessionId As Integer, ByVal nTimeout As Integer) As Boolean
        Return m_objVaxServerSIP.AddCallSessionToQueue(sQueueName, sCallerName, sCallerId, nSessionId, nTimeout)
    End Function

    Public Function RemoveCallSessionFromQueue(ByVal nSessionId As Integer) As Boolean
        Return m_objVaxServerSIP.RemoveCallSessionFromQueue(nSessionId)
    End Function

    Public Function AddStealthListener(ByVal nStealthSessionId As Integer, ByVal sCapturePeerName As String) As Boolean
        Return m_objVaxServerSIP.AddStealthListener(nStealthSessionId, sCapturePeerName)
    End Function

    Public Function SetExtDataREC(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal sExtData As String) As Boolean
        Return m_objVaxServerSIP.SetExtDataREC(nSessionId, nChannelId, sExtData)
    End Function

    Public Function ConnectToServerREC(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String, ByVal sToPeerName As String, ByVal nTimeout As Integer) As Boolean
        Return m_objVaxServerSIP.ConnectToServerREC(nSessionId, nChannelId, sCallerName, sCallerId, sDialNo, sToPeerName, nTimeout)
    End Function

    Public Function AdjustCallSessionVoiceType(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nVoiceTypeId As Integer) As Boolean
        Return m_objVaxServerSIP.AdjustCallSessionVoiceType(nSessionId, nChannelId, nVoiceTypeId)
    End Function

    Public Function AdjustCallSessionVideoType(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nVideoTypeId As Integer) As Boolean
        Return m_objVaxServerSIP.AdjustCallSessionVideoType(nSessionId, nChannelId, nVideoTypeId)
    End Function

    Public Function MuteCallServerREC(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal bMuteType As Integer) As Boolean
        Return m_objVaxServerSIP.MuteCallServerREC(nSessionId, nChannelId, bMuteType)
    End Function

    Public Function GetUserAgentNameCall(nSessionId As Integer, nChannelId As Integer) As String
        Return m_objVaxServerSIP.GetUserAgentNameCall(nSessionId, nChannelId)
    End Function

    Public Function SendReqTransferCallBlind(nSessionId As Integer, nChannelId As Integer, sToUserName As String) As Boolean
        Return m_objVaxServerSIP.SendReqTransferCallBlind(nSessionId, nChannelId, sToUserName)
    End Function

    Public Function SendReqTransferCallConsult(nSessionId As Integer, nChannelId As Integer, nToSessionId As Integer, nToChannelId As Integer) As Boolean
        Return m_objVaxServerSIP.SendReqTransferCallConsult(nSessionId, nChannelId, nToSessionId, nToChannelId)
    End Function

    Public Function SendReqHoldCall(nSessionId As Integer, nChannelId As Integer) As Boolean
        Return m_objVaxServerSIP.SendReqHoldCall(nSessionId, nChannelId)
    End Function

    Public Function SendReqUnHoldCall(nSessionId As Integer, nChannelId As Integer) As Boolean
        Return m_objVaxServerSIP.SendReqUnHoldCall(nSessionId, nChannelId)
    End Function

    Public Function AddNetworkRouteSIP(ByVal sAssignedIP As String, ByVal sRouterIP As String) As Boolean
        Return m_objVaxServerSIP.AddNetworkRouteSIP(sAssignedIP, sRouterIP)
    End Function

    Public Function AddNetworkRouteRTP(ByVal sAssignedIP As String, ByVal sRouterIP As String) As Boolean
        Return m_objVaxServerSIP.AddNetworkRouteRTP(sAssignedIP, sRouterIP)
    End Function

    Public Function SendNotifyMsgSIP(ByVal sMsgFrom As String, ByVal sMsgTo As String, ByVal sToPeerName As String) As Integer
        Return m_objVaxServerSIP.SendNotifyMsgSIP(sMsgFrom, sMsgTo, sToPeerName)
    End Function

    Public Function RefreshCallSession(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sAudioCodecList As String, ByVal nAudioFlowType As Integer, ByVal nVideoFlowType As Integer, ByVal nTimeout As Integer) As Boolean
        Return m_objVaxServerSIP.RefreshCallSession(nSessionId, nChannelId, sCallerName, sCallerId, sAudioCodecList, nAudioFlowType, nVideoFlowType, nTimeout)
    End Function

    Public Function SendAudioPCM(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal aDataPCM As Byte(), ByVal nSizePCM As Integer) As Boolean
        Dim hHandleGC As GCHandle = GCHandle.Alloc(aDataPCM, GCHandleType.Pinned)
        Dim AddrDataPCM As IntPtr = hHandleGC.AddrOfPinnedObject()
        Dim lDataPCM As Long = AddrDataPCM.ToInt64()
        Dim bResult As Boolean = m_objVaxServerSIP.SendAudioPCM(nSessionId, nChannelId, lDataPCM, nSizePCM, 0)
        hHandleGC.Free()
        Return bResult
    End Function

    Public Function AccessAudioPCM(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal sPipeName As String, ByVal nAccessType As Integer) As Boolean
        Return m_objVaxServerSIP.AccessAudioPCM(nSessionId, nChannelId, sPipeName, nAccessType)
    End Function

    Public Function ActivatePushSIP(ByVal bActivate As Boolean, ByVal nWaitSeconds As Integer) As Boolean
        Return m_objVaxServerSIP.ActivatePushSIP(bActivate, nWaitSeconds)
    End Function

    Public Function CallSessionAttachCall(ByVal nSessionId As Integer, ByVal nVoiceTypeId As Integer, ByVal nVideoTypeId As Integer, ByVal nAttachToSessionId As Integer, ByVal nAttachToChannelId As Integer) As Boolean
        Return m_objVaxServerSIP.CallSessionAttachCall(nSessionId, nVoiceTypeId, nVideoTypeId, nAttachToSessionId, nAttachToChannelId)
    End Function

    Public Sub CallSessionDetachCall(ByVal nSessionId As Integer, ByVal nVoiceTypeId As Integer, ByVal nVideoTypeId As Integer)
        m_objVaxServerSIP.CallSessionDetachCall(nSessionId, nVoiceTypeId, nVideoTypeId)
    End Sub

    Public Function AddUserRouteUID(ByVal sUserName As String, ByVal sRouteUID As String) As Boolean
        Return m_objVaxServerSIP.AddUserRouteUID(sUserName, sRouteUID)
    End Function

    Public Function AddLineRouteUID(ByVal sLineName As String, ByVal sRouteUID As String, ByVal sDialOutPrefix As String) As Boolean
        Return m_objVaxServerSIP.AddLineRouteUID(sLineName, sRouteUID, sDialOutPrefix)
    End Function

    Public Function AddRingGroupRouteUID(ByVal sGroupName As String, ByVal sRouteUID As String) As Boolean
        Return m_objVaxServerSIP.AddRingGroupRouteUID(sGroupName, sRouteUID)
    End Function

    Public Function AddCallPickUpGroupRouteUID(ByVal sRouteUID As String) As Boolean
        Return m_objVaxServerSIP.AddCallPickUpGroupRouteUID(sRouteUID)
    End Function

    Public Function AddQueueRouteUID(ByVal sQueueName As String, ByVal sRouteUID As String) As Boolean
        Return m_objVaxServerSIP.AddQueueRouteUID(sQueueName, sRouteUID)
    End Function

    Public Function AddCallParkRouteUID(ByVal sRouteUID As String) As Boolean
        Return m_objVaxServerSIP.AddCallParkRouteUID(sRouteUID)
    End Function

    Public Function AddConferenceRoomRouteUID(ByVal sRoomName As String, ByVal sRouteUID As String) As Boolean
        Return m_objVaxServerSIP.AddConferenceRoomRouteUID(sRoomName, sRouteUID)
    End Function

    Public Function AddStealthListenRouteUID(ByVal sRouteUID As String) As Boolean
        Return m_objVaxServerSIP.AddStealthListenRouteUID(sRouteUID)
    End Function

    Public Sub RemoveRouteUID(ByVal sRouteUID As String)
        m_objVaxServerSIP.RemoveRouteUID(sRouteUID)
    End Sub

    Public Function AttackDetectScanSIP(sDomainName As String) As Boolean
        Return m_objVaxServerSIP.AttackDetectScanSIP(sDomainName)
    End Function

    Public Function AttackDetectFloodSIP(nReqRecvLimit As Integer) As Boolean
        Return m_objVaxServerSIP.AttackDetectFloodSIP(nReqRecvLimit)
    End Function

    Public Function AttackDetectBruteForceSIP(nFailureCount As Integer, nFailureInterval As Integer) As Boolean
        Return m_objVaxServerSIP.AttackDetectBruteForceSIP(nFailureCount, nFailureInterval)
    End Function

    Public Function DetectStartVAD(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nAudioLevelVU As Integer, ByVal nSilenceLengthPCM As Integer, ByVal nSilenceCountPCM As Integer, ByVal nAnalysisLengthPCM As Integer, ByVal nExpiryLengthPCM As Integer, ByVal nProcessLengthPCM As Integer, ByVal nDetectType As Integer) As Boolean
        Return m_objVaxServerSIP.DetectStartVAD(nSessionId, nChannelId, nAudioLevelVU, nSilenceLengthPCM, nSilenceCountPCM, nAnalysisLengthPCM, nExpiryLengthPCM, nProcessLengthPCM, nDetectType)
    End Function

    Public Sub DetectStopVAD(ByVal nSessionId As Integer, ByVal nChannelId As Integer)
        m_objVaxServerSIP.DetectStopVAD(nSessionId, nChannelId)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////////////

    Protected Overridable Sub OnLineRegisterTrying(ByVal sLineName As String)
    End Sub

    Protected Overridable Sub OnLineRegisterFailed(ByVal sLineName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Protected Overridable Sub OnLineRegisterSuccess(ByVal sLineName As String)
    End Sub

    Protected Overridable Sub OnLineUnRegisterTrying(ByVal sLineName As String)
    End Sub

    Protected Overridable Sub OnLineUnRegisterFailed(ByVal sLineName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Protected Overridable Sub OnLineUnRegisterSuccess(ByVal sLineName As String)
    End Sub

    Protected Overridable Sub OnUnRegisterUser(ByVal sUserName As String)
    End Sub

    Protected Overridable Sub OnRegisterUser(ByVal sUserName As String, ByVal sDomain As String, ByVal sUserAgentName As String, ByVal sFromIP As String, ByVal nFromPort As Integer, ByVal nRegId As Integer)
    End Sub

    Protected Overridable Sub OnRegisterUserFailed(ByVal sUserName As String, ByVal sFromIP As String, ByVal nFromPort As Integer, ByVal nRegId As Integer)
    End Sub

    Protected Overridable Sub OnRegisterUserPushSIP(ByVal sUserName As String, ByVal nProviderPN As Integer, ByVal sProjectPN As String, ByVal sDevicePN As String)
    End Sub

    Protected Overridable Sub OnRegisterUserSuccess(ByVal sUserName As String, ByVal sFromIP As String, ByVal nFromPort As Integer, ByVal nRegId As Integer)
    End Sub

    Protected Overridable Sub OnChatMessageText(ByVal nChatMsgId As Integer, ByVal sMsgFrom As String, ByVal sMsgTo As String, ByVal sMsgText As String, ByVal nFromPeerType As Integer, ByVal sFromPeerName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
    End Sub

    Protected Overridable Sub OnChatMessageTyping(ByVal nChatMsgId As Integer, ByVal sMsgFrom As String, ByVal sMsgTo As String, ByVal bIsTypingStart As Boolean, ByVal nFromPeerType As Integer, ByVal sFromPeerName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
    End Sub

    Protected Overridable Sub OnChatStatusSubscribe(ByVal nSubscrbId As Integer, ByVal sMsgFrom As String, ByVal sMsgTo As String, ByVal nFromPeerType As Integer, ByVal sFromPeerName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
    End Sub

    Protected Overridable Sub OnChatStatusSendSubscribeSuccess(ByVal SubscrbId As Integer)
    End Sub

    Protected Overridable Sub OnChatStatusSendSubscribeFailed(ByVal SubscrbId As Integer, ByVal StatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Protected Overridable Sub OnChatMessageSuccess(ByVal nChatMsgId As Integer)
    End Sub

    Protected Overridable Sub OnChatMessageFailed(ByVal nChatMsgId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Protected Overridable Sub OnChatMessageTimeout(ByVal nChatMsgId As Integer)
    End Sub

    Protected Overridable Sub OnIncomingCall(ByVal nSessionId As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String, ByVal nFromPeerType As Integer, ByVal sFromPeerName As String, ByVal sRouteUID As String, ByVal nRouteType As Integer, ByVal sRouteName As String, ByVal sUserAgentName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
    End Sub

    Protected Overridable Sub OnCallSessionConnecting(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Protected Overridable Sub OnCallSessionFailed(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String, ByVal sContact As String)
    End Sub

    Protected Overridable Sub OnCallSessionConnected(ByVal nSessionId As Integer)
    End Sub

    Protected Overridable Sub OnCallSessionClosed(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nReasonCode As Integer)
    End Sub

    Protected Overridable Sub OnCallSessionLost(ByVal nSessionId As Integer, ByVal nChannelId As Integer)
    End Sub

    Protected Overridable Sub OnCallSessionHangup(ByVal nSessionId As Integer, ByVal nChannelId As Integer)
    End Sub

    Protected Overridable Sub OnCallSessionTimeout(ByVal nSessionId As Integer, ByVal nChannelId As Integer)
    End Sub

    Protected Overridable Sub OnCallSessionCancelled(ByVal nSessionId As Integer)
    End Sub

    Protected Overridable Sub OnCallSessionOnHold(ByVal nSessionId As Integer, ByVal nChannelId As Integer)
    End Sub

    Protected Overridable Sub OnCallSessionOffHold(ByVal nSessionId As Integer, ByVal nChannelId As Integer)
    End Sub

    Protected Overridable Sub OnCallSessionTransferBlind(ByVal nTransfererSessionId As Integer, ByVal nTransfererChannelId As Integer, ByVal sTransferer As String, ByVal sTransferee As String, ByVal sTransferTo As String, ByVal sRouteUID As String, ByVal nRouteType As Integer, ByVal sRouteName As String)
    End Sub

    Protected Overridable Sub OnCallSessionTransferConsult(ByVal nTransfererSessionId As Integer, ByVal nTransfererChannelId As Integer, ByVal nTransferToSessionId As Integer, ByVal nTransferToChannelId As Integer, ByVal sTransferer As String, ByVal sTransferee As String, ByVal sTransferTo As String)
    End Sub

    Protected Overridable Sub OnCallSessionTransfering(ByVal nSessionId As Integer, ByVal nTransferType As Integer, ByVal nChannelId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Protected Overridable Sub OnCallSessionTransferFailed(ByVal nSessionId As Integer, ByVal nTransferType As Integer, ByVal nChannelId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Protected Overridable Sub OnCallSessionTransferTimeout(ByVal nSessionId As Integer, ByVal nTransferType As Integer, ByVal nChannelId As Integer)
    End Sub

    Protected Overridable Sub OnCallSessionTransfered(ByVal nSessionId As Integer, ByVal nTransferType As Integer)
    End Sub

    Protected Overridable Sub OnDetectedDigitDTMF(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal sDigitDTMF As String, ByVal nTypeDTMF As Integer)
    End Sub

    Protected Overridable Sub OnOutgoingDiagnosticLog(ByVal sMsgSIP As String, ByVal sToIP As String, ByVal nToPort As Integer)
    End Sub

    Protected Overridable Sub OnIncomingDiagnosticLog(ByVal sMsgSIP As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
    End Sub

    Protected Overridable Sub OnVaxTeleTick(ByVal nTickId As Integer)
    End Sub

    Protected Overridable Sub OnSendTimeoutVM(ByVal nMsgIdVM As Integer)
    End Sub

    Protected Overridable Sub OnSendSuccessVM(ByVal nMsgIdVM As Integer)
    End Sub

    Protected Overridable Sub OnCallSessionDialToneStarted(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nWaveId As Integer)
    End Sub

    Protected Overridable Sub OnCallSessionDialToneEnded(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nWaveId As Integer)
    End Sub

    Protected Overridable Sub OnCallSessionPlayWaveDone(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nWaveId As Integer)
    End Sub

    Protected Overridable Sub OnConferenceRoomPlayWaveDone(ByVal sRoomName As String, ByVal nWaveId As Integer)
    End Sub

    Protected Overridable Sub OnCallSessionCreated(ByVal nSessionId As Integer, ByVal nReasonCode As Integer)
    End Sub

    Protected Overridable Sub OnCallSessionDetectedAMD(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal bIsHuman As Boolean)
    End Sub

    Private Sub OnCallSessionRecordedWaveREC(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal lDataREC As Long, ByVal nSizeREC As Integer, ByVal nTypeREC As Integer)
        Dim aDataREC As Byte() = New Byte(nSizeREC - 1) {}
        Marshal.Copy(New IntPtr(lDataREC), aDataREC, 0, nSizeREC)
        OnCallSessionRecordedWaveREC(nSessionId, aDataREC, nSizeREC, nTypeREC)
    End Sub

    Protected Overridable Sub OnCallSessionRecordedWaveREC(ByVal nSessionId As Integer, ByVal aDataREC As Byte(), ByVal nSizeREC As Integer, ByVal nTypeREC As Integer)
    End Sub

    Private Sub OnConferenceRoomRecordedWaveREC(ByVal sRoomName As String, ByVal lDataREC As Long, ByVal nSizeREC As Integer, ByVal nTypeREC As Integer)
        Dim aDataREC As Byte() = New Byte(nSizeREC - 1) {}
        Marshal.Copy(New IntPtr(lDataREC), aDataREC, 0, nSizeREC)
        OnConferenceRoomRecordedWaveREC(sRoomName, aDataREC, nSizeREC, nTypeREC)
    End Sub

    Protected Overridable Sub OnConferenceRoomRecordedWaveREC(ByVal sRoomName As String, ByVal aDataREC As Byte(), ByVal nSizeREC As Integer, ByVal nTypeREC As Integer)
    End Sub

    Protected Overridable Sub OnBusyLampSubscribe(ByVal nSubScrbId As Integer, ByVal sUserName As String, ByVal sToUserName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
    End Sub

    Protected Overridable Sub OnBusyLampSendStatus(ByVal sFromUserName As String, ByVal sToUserName As String, ByVal nStateId As Integer)
    End Sub

    Protected Overridable Sub OnBusyLampUnSubscribe(ByVal nSubScrbId As Integer, ByVal sUserName As String, ByVal sToUserName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
    End Sub

    Protected Overridable Sub OnBusyLampSubscribeSuccess(ByVal nSubScrbId As Integer, ByVal sUserName As String)
    End Sub

    Protected Overridable Sub OnBusyLampSubscribeFailed(ByVal nSubScrbId As Integer, ByVal sUserName As String)
    End Sub

    Protected Overridable Sub OnAddCallSessionToQueueSuccess(ByVal sQueueName As String, ByVal nSessionId As Integer)
    End Sub

    Protected Overridable Sub OnAddCallSessionToQueueFailed(ByVal sQueueName As String, ByVal nSessionId As Integer)
    End Sub

    Protected Overridable Sub OnQueuePlayWaveStarted(ByVal nEventType As Integer, ByVal sQueueName As String, ByVal nSessionId As Integer)
    End Sub

    Protected Overridable Sub OnQueuePlayWaveEnded(ByVal nEventType As Integer, ByVal sQueueName As String, ByVal nSessionId As Integer)
    End Sub

    Protected Overridable Sub OnAddCallSessionToRingGroupSuccess(ByVal sGroupName As String, ByVal nSessionId As Integer)
    End Sub

    Protected Overridable Sub OnAddCallSessionToRingGroupFailed(ByVal sGroupName As String, ByVal nSessionId As Integer)
    End Sub

    Protected Overridable Sub OnSendReqTransferCallTimeout(ByVal nSessionId As Integer, ByVal nChannelId As Integer)
    End Sub

    Protected Overridable Sub OnSendReqTransferCallAccepted(ByVal nSessionId As Integer, ByVal nChannelId As Integer)
    End Sub

    Protected Overridable Sub OnSendReqTransferCallFailed(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Protected Overridable Sub OnQualityReportPUBLISH(ByVal sMsgSIP As String, ByVal sMsgSDP As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
    End Sub

    Protected Overridable Sub OnServerConnectingREC(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Protected Overridable Sub OnServerConnectedREC(ByVal nSessionId As Integer, ByVal nChannelId As Integer)
    End Sub

    Protected Overridable Sub OnServerFailedREC(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Protected Overridable Sub OnServerTimeoutREC(ByVal nSessionId As Integer, ByVal nChannelId As Integer)
    End Sub

    Protected Overridable Sub OnServerHungupREC(ByVal nSessionId As Integer, ByVal nChannelId As Integer)
    End Sub

    Protected Overridable Sub OnQueueAgentConnectStarted(ByVal sQueueName As String, ByVal sAgentName As String, ByVal nSessionId As Integer)
    End Sub

    Protected Overridable Sub OnQueueAgentConnectTrying(ByVal sQueueName As String, ByVal sAgentName As String, ByVal nSessionId As Integer, ByVal StatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Protected Overridable Sub OnQueueAgentConnectFailed(ByVal sQueueName As String, ByVal sAgentName As String, ByVal nSessionId As Integer, ByVal StatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Protected Overridable Sub OnQueueAgentConnectTimeout(ByVal sQueueName As String, ByVal sAgentName As String, ByVal nSessionId As Integer)
    End Sub

    Protected Overridable Sub OnQueueAgentConnectSuccess(ByVal sQueueName As String, ByVal sAgentName As String, ByVal nSessionId As Integer)
    End Sub

    Protected Overridable Sub OnSendNotifyMsgSuccess(ByVal nMsgId As Integer)
    End Sub

    Protected Overridable Sub OnSendNotifyMsgFailed(ByVal nMsgId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    '//////////////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////////////

    Protected Overridable Sub OnCallParkPlayWaveStarted(ByVal nSessionId As Integer, ByVal nChannelId As Integer)
    End Sub

    Protected Overridable Sub OnCallParkPlayWaveEnded(ByVal nSessionId As Integer, ByVal nChannelId As Integer)
    End Sub

    '//////////////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////////////

    Private Sub OnCallSessionAccessAudioPCM(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nAccessType As Integer, ByVal lDataPCM As Long, ByVal nSizePCM As Integer, ByVal nTypePCM As Integer)
        Dim aDataPCM As Byte() = New Byte(nSizePCM - 1) {}
        Marshal.Copy(New IntPtr(lDataPCM), aDataPCM, 0, nSizePCM)
        OnCallSessionAccessAudioPCM(nSessionId, nChannelId, nAccessType, aDataPCM, nSizePCM, nTypePCM)
    End Sub

    Protected Overridable Sub OnCallSessionAccessAudioPCM(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nAccessType As Integer, ByVal aDataPCM As Byte(), ByVal nSizePCM As Integer, ByVal nTypePCM As Integer)
    End Sub

    '//////////////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////////////

    Protected Overridable Sub OnCallSessionPushSIP(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal nProviderPN As Integer, ByVal sProjectPN As String, ByVal sDevicePN As String)
    End Sub

    Protected Overridable Sub OnStealthListenerAttached(ByVal nAttachType As Integer, ByVal nStealthSessionId As Integer, ByVal nAttachSessionId As Integer, ByVal nAttachChannelId As Integer)
    End Sub

    '//////////////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////////////

    Protected Overridable Sub OnSendReqHoldCallSuccess(nSessionId As Integer, nChannelId As Integer)

    End Sub

    Protected Overridable Sub OnSendReqHoldCallTrying(nSessionId As Integer, nChannelId As Integer)

    End Sub

    Protected Overridable Sub OnSendReqHoldCallTimeout(nSessionId As Integer, nChannelId As Integer)

    End Sub

    Protected Overridable Sub OnSendReqHoldCallFailed(nSessionId As Integer, nChannelId As Integer, nStatusCode As Integer, sReasonPhrase As String)

    End Sub

    '//////////////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////////////

    Protected Overridable Sub OnSendReqUnHoldCallSuccess(nSessionId As Integer, nChannelId As Integer)

    End Sub

    Protected Overridable Sub OnSendReqUnHoldCallTrying(nSessionId As Integer, nChannelId As Integer)

    End Sub

    Protected Overridable Sub OnSendReqUnHoldCallTimeout(nSessionId As Integer, nChannelId As Integer)

    End Sub

    Protected Overridable Sub OnSendReqUnHoldCallFailed(nSessionId As Integer, nChannelId As Integer, nStatusCode As Integer, sReasonPhrase As String)

    End Sub

    '//////////////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////////////

    Protected Overridable Sub OnVaxErrorLog(ByVal sFuncName As String, ByVal nErrorCode As Integer, ByVal sErrorMsg As String)
    End Sub

    Protected Overridable Sub OnCallSessionErrorLog(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nErrorCode As Integer, ByVal sErrorMsg As String)
    End Sub

    '//////////////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////////////

    Protected Overridable Sub OnAttackDetectedScanSIP(sReqMethod As String, sAddrIP As String, nAddrPort As Integer, nAddrType As Integer)
    End Sub

    Protected Overridable Sub OnAttackDetectedFloodSIP(sAddrIP As String, nAddrPort As Integer, nAddrType As Integer)
    End Sub

    Protected Overridable Sub OnAttackDetectedBruteForceSIP(sReqMethod As String, nAuthFailureCount As Integer, sAddrIP As String, nAddrPort As Integer, nAddrType As Integer)
    End Sub

    '//////////////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////////////

    Protected Overridable Sub OnCallSessionMediaDetectStartedVAD(ByVal nSessionId As Integer, ByVal nChannelId As Integer)
    End Sub

    Private Sub OnCallSessionMediaDetectCompletedVAD(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal lDataPCM As Long, ByVal nSizePCM As Integer, ByVal nTypePCM As Integer)
        Dim aDataPCM As Byte() = New Byte(nSizePCM - 1) {}
        Marshal.Copy(New IntPtr(lDataPCM), aDataPCM, 0, nSizePCM)
        OnCallSessionMediaDetectCompletedVAD(nSessionId, nChannelId, aDataPCM, nSizePCM, nTypePCM)
    End Sub

    Protected Overridable Sub OnCallSessionMediaDetectCompletedVAD(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal aDataPCM As Byte(), ByVal nSizePCM As Integer, ByVal nTypePCM As Integer)
    End Sub

    Protected Overridable Sub OnCallSessionMediaDetectExpiredVAD(ByVal nSessionId As Integer, ByVal nChannelId As Integer)
    End Sub

End Class
