﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.IO

Namespace AutoDialer
    Class cFileCSV
        Private m_sFilePath As String

        Public Sub New(ByVal sFilePath As String)
            m_sFilePath = sFilePath
        End Sub

        Public Function GetDataCSV(ByRef objListPhoneNo As List(Of String), ByRef objListPhoneStatus As List(Of String), ByRef objListDTMF As List(Of String), ByRef objListDuration As List(Of String)) As Boolean

            If m_sFilePath = "" Then Return False

            Try
                Dim objStreamReader = New StreamReader(File.OpenRead(m_sFilePath))

                While Not objStreamReader.EndOfStream
                    Dim line = objStreamReader.ReadLine()
                    Dim values = line.Split(","c)
                    If values(0).ToString().Length = 0 Then values(0) = "  "
                    If values(1).ToString().Length = 0 Then values(1) = "  "
                    If values(2).ToString().Length = 0 Then values(2) = "  "
                    If values(3).ToString().Length = 0 Then values(3) = "  "
                    objListPhoneNo.Add(values(0).ToString())
                    objListPhoneStatus.Add(values(1).ToString())
                    objListDTMF.Add(values(2).ToString())
                    objListDuration.Add(values(3).ToString())
                End While

                objStreamReader.Close()
            Catch objException As Exception
                Return False
            End Try

            Return True

        End Function

        Public Function WriteDataCSV(ByVal objListPhoneNo As List(Of String), ByVal objListPhoneStatus As List(Of String), ByVal objListDTMF As List(Of String), ByVal objListDuration As List(Of String)) As Boolean

            If m_sFilePath = "" Then Return False
            If objListPhoneNo.Count <> objListPhoneStatus.Count() Then Return False

            Try

                Using objStreamWriter = New StreamWriter(m_sFilePath)

                    For nIndex As Integer = 0 To objListPhoneNo.Count - 1
                        Dim sline As String = String.Format("{0},{1},{2},{3}", objListPhoneNo(nIndex), objListPhoneStatus(nIndex), objListDTMF(nIndex), objListDuration(nIndex))
                        objStreamWriter.WriteLine(sline)
                        objStreamWriter.Flush()
                    Next
                End Using

            Catch objException As Exception
                Return False
            End Try

            Return True

        End Function

    End Class

End Namespace
