﻿Imports System
Imports System.Collections

Namespace BasicIVR
    Class cVaxCallSessionList

        Private m_objDataList As Hashtable = Nothing

        Public Sub New()
            m_objDataList = New Hashtable(4096)
        End Sub

        Public Sub AddSession(ByVal nSessionId As Integer)
            If m_objDataList.ContainsKey(nSessionId) Then Return
            Dim objData As cVaxCallSession = New cVaxCallSession()
            objData.m_nSessionId = nSessionId
            m_objDataList.Add(nSessionId, objData)
        End Sub

        Public Function GetSession(ByVal nSessionId As Integer) As cVaxCallSession
            Return CType(m_objDataList(nSessionId), cVaxCallSession)
        End Function

        Public Function FindPhoneNoSession(ByVal nPhoneNoId As UInt32) As cVaxCallSession
            Dim objDataEnum As IDictionaryEnumerator = m_objDataList.GetEnumerator()
            Dim objDataEntry As DictionaryEntry

            While objDataEnum.MoveNext()
                objDataEntry = CType(objDataEnum.Current, DictionaryEntry)
                Dim objData As cVaxCallSession = CType(objDataEntry.Value, cVaxCallSession)

                If objData.m_nPhoneNoId = nPhoneNoId Then
                    Return objData
                End If
            End While

            Return Nothing
        End Function

        Public Function IsExist(ByVal nSessionId As Integer) As Boolean
            Return m_objDataList.ContainsKey(nSessionId)
        End Function

        Public Sub RemoveSession(ByVal nSessionId As Integer)
            m_objDataList.Remove(nSessionId)
        End Sub

        Public Sub ClearAll()
            m_objDataList.Clear()
        End Sub

    End Class

End Namespace
