﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.IO
Imports System.Data

Namespace BasicIVR
    Class CGenFileLocation

        Public Function GenRecordingFilePath(ByVal nSessionId As Integer, ByVal sDefaultPath As String) As String
            If sDefaultPath.Length = 0 Then Return ""
            Dim sFolderPath As String = GetFullPath(sDefaultPath)
            If sFolderPath.Length = 0 Then Return ""
            Dim sFilePath As String = String.Format("{0}\{1}.wav", sFolderPath, nSessionId)
            Return sFilePath
        End Function

        Private Function GetFullPath(ByVal sDefaultPath As String) As String
            Dim objDirInfo As DirectoryInfo

            If Not Directory.Exists(sDefaultPath) Then
                objDirInfo = Directory.CreateDirectory(sDefaultPath)
                If Not objDirInfo.Exists Then Return ""
            End If

            Dim objDateTime As DateTime = DateTime.Now
            Dim sFullPath As String = String.Format("{0}\{1}\{2}\{3}", sDefaultPath, objDateTime.Year, objDateTime.Month, objDateTime.Day)
            objDirInfo = Directory.CreateDirectory(sFullPath)
            If Not objDirInfo.Exists Then Return ""
            Return sFullPath
        End Function

    End Class

End Namespace
